﻿package 
{

	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;

	import flash.external.ExternalInterface;
	import flash.text.TextField;
	import fl.controls.Button;
	import com.facebook.graph.Facebook;
	import com.adobe.serialization.json.JSON;

	public class DocumentClass extends MovieClip
	{
		//自分が登録したFacebookアプリのIDに変更してください。
		private var APPLICATION_ID:String = 'YOUR_APPLICATION_ID';
		
		private var _myID:String;			//自分のユーザID。
		private var _accessToken:String;	//APIを叩くためのアクセストークン。
		
		public var button:Button;
		public var tf:TextField;
		
		public function DocumentClass()
		{
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		private function init(evt:Event = null):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tf.text = 'ver 0.0.3\n';

			button.addEventListener(MouseEvent.CLICK, onClick);
			tf.mouseWheelEnabled = true;
		}
		private function onClick(evt:MouseEvent):void
		{
			button.removeEventListener(MouseEvent.CLICK, onClick);

			//Facebook　を初期化します。
			tf.appendText('Facebook.init();　初期化を開始します...\n');

			//Facebook.init('取得したアプリケーションID', initCallBack);　このメソッドで初期化します。うまく行けば、コールバックが返ってきます。
			Facebook.init(this.APPLICATION_ID, initCallBack);
		}
		
		private function initCallBack(response:Object, fail:Object = null):void
		{
			tf.appendText('initCallBack\n');
			if (response)
			{
				//初期化成功。
				tf.appendText('Facebook　初期化に成功.\n');
				tf.appendText('あなたのユーザID：' + response.uid + '\n');
			}
			else
			{
				//初期化失敗
				tf.appendText('Facebook　初期化に失敗.\n');
			}
			
			//認証を実行します。
			tf.appendText('Facebook.login();　認証を開始します...\n');
			//セッション状態が変わった時に呼ばれる関数を設定しておきます。
			ExternalInterface.addCallback('sessionChange', onSessionChangeHandler);
			//アプリが実行する操作範囲　（参照：Extended Permissions - http://developers.facebook.com/docs/authentication/permissions
			var permissions:Array = ['publish_stream'];
			//認証を実行します。第1引数にはコールバック関数、第2引数にパーミッションを渡します;
			Facebook.login(loginCallBack, {perms:permissions.join(',')});

		}
		
		private function loginCallBack(response:Object, fail:Object):void
		{
			//ログイン完了
			if (response)
			{
				tf.appendText('ログイン・認証に成功.\n');
				tf.appendText('あなたのユーザID：' + response.uid + '\n');
			}
			else
			{
				tf.appendText('ログイン・認証に失敗.\n');
			}
		}

		private function onSessionChangeHandler(session:String, extendedPermissions:Object = null):void
		{
			//セッション状態に変更あり。
			tf.appendText('セッション状態に変更あり.\n');
			if (session)
			{
				//JSONなのでデコードします。
				var response:Object = JSON.decode(session);

				tf.appendText('あなたのユーザID：' + response.uid + '\n');
				//ここでアクセストークンを取得することができます
				tf.appendText('アクセストークン：' + response.access_token + '\n');

				this._myID = response.uid;
				this._accessToken = response.access_token;

				//自分のIDとアクセストークンを取得しました。これでAPI使用の準備が出来ました。
				readyToUseAPI();
			}
			else
			{
			}
		}
		
		private function readyToUseAPI():void
		{
			//APIの準備完了。
			button.label = '友達一覧取得';
			button.addEventListener(MouseEvent.CLICK, loadFriends);
		}
		
		private function loadFriends(evt:MouseEvent):void
		{
			//友達一覧をロードしてみます
			tf.appendText('友達一覧をロード\n');
			//APIは、 Facebook.api('リクエストするAPI', コールバック関数, {access_token:アクセストークン文字列}); で叩きます。
			//友達一覧取得のAPIは /me/frineds です。
			Facebook.api('/me/friends', loadFriendsHandler, {access_token:this._accessToken});
		}
		private function loadFriendsHandler(response:Object, fail:Object):void
		{
			if (response)
			{
				tf.appendText('友達一覧取得成功\n');
				var friends:Array = response as Array;
				for (var i:int = 0; i < friends.length; i ++)
				{
					tf.appendText(friends[i].name + 'さん　ユーザid：' + friends[i].id + '\n');
				}
			}
			else
			{
			}
		}

	}

}